aubio 0.4.9

Loading...
Searching...
No Matches
lvec.h
Go to the documentation of this file.
1/*
2 Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
3
4 This file is part of aubio.
5
6 aubio is free software: you can redistribute it and/or modify
7 it under the terms of the GNU General Public License as published by
8 the Free Software Foundation, either version 3 of the License, or
9 (at your option) any later version.
10
11 aubio is distributed in the hope that it will be useful,
12 but WITHOUT ANY WARRANTY; without even the implied warranty of
13 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 GNU General Public License for more details.
15
16 You should have received a copy of the GNU General Public License
17 along with aubio. If not, see <http://www.gnu.org/licenses/>.
18
19*/
20
21#ifndef AUBIO_LVEC_H
22#define AUBIO_LVEC_H
23
24#ifdef __cplusplus
25 extern "C" {
26#endif
27
28/** \file
29
30 Vector of real-valued data in double precision
31
32 This file specifies the ::lvec_t buffer type, which is used in some places in
33 aubio to store a vector of ::lsmp_t.
34
35 Note: the lvec_t data type is required in some algorithms such as IIR filters
36 (see temporal/filter.h).
37
38 \example test-lvec.c
39
40*/
41
42/** Buffer for real data in double precision */
43 typedef struct {
44 uint_t length; /**< length of buffer */
45 lsmp_t *data; /**< data array of size [length] */
46} lvec_t;
47
48/** lvec_t buffer creation function
49
50 \param length the length of the buffer to create
51
52*/
53 lvec_t * new_lvec(uint_t length);
54/** lvec_t buffer deletion function
55
56 \param s buffer to delete as returned by new_lvec()
57
58*/
59 void del_lvec(lvec_t *s);
60
61/** read sample value in a buffer
62
63 \param s vector to read from
64 \param position sample position to read from
65
66*/
67 lsmp_t lvec_get_sample(lvec_t *s, uint_t position);
68
69/** write sample value in a buffer
70
71 \param s vector to write to
72 \param data value to write in s->data[position]
73 \param position sample position to write to
74
75*/
76 void lvec_set_sample(lvec_t *s, lsmp_t data, uint_t position);
77
78/** read data from a buffer
79
80 \param s vector to read from
81
82*/
83 lsmp_t * lvec_get_data(const lvec_t *s);
84
85/** print out lvec data
86
87 \param s vector to print out
88
89*/
90 void lvec_print(const lvec_t *s);
91
92/** set all elements to a given value
93
94 \param s vector to modify
95 \param val value to set elements to
96
97*/
98 void lvec_set_all(lvec_t *s, smpl_t val);
99
100/** set all elements to zero
101
102 \param s vector to modify
103
104*/
105 void lvec_zeros(lvec_t *s);
106
107/** set all elements to ones
108
109 \param s vector to modify
110
111*/
112 void lvec_ones(lvec_t *s);
113
114#ifdef __cplusplus
115}
116#endif
117
118#endif /* AUBIO_LVEC_H */
lvec_ones
void lvec_ones(lvec_t *s)
set all elements to ones
lvec_zeros
void lvec_zeros(lvec_t *s)
set all elements to zero
del_lvec
void del_lvec(lvec_t *s)
lvec_t buffer deletion function
lvec_get_sample
lsmp_t lvec_get_sample(lvec_t *s, uint_t position)
read sample value in a buffer
new_lvec
lvec_t * new_lvec(uint_t length)
lvec_t buffer creation function
lvec_set_all
void lvec_set_all(lvec_t *s, smpl_t val)
set all elements to a given value
lvec_set_sample
void lvec_set_sample(lvec_t *s, lsmp_t data, uint_t position)
write sample value in a buffer
lvec_print
void lvec_print(const lvec_t *s)
print out lvec data
lvec_get_data
lsmp_t * lvec_get_data(const lvec_t *s)
read data from a buffer
lvec_t
Buffer for real data in double precision.
Definition: lvec.h:43
lvec_t::length
uint_t length
length of buffer
Definition: lvec.h:44
lvec_t::data
lsmp_t * data
data array of size [length]
Definition: lvec.h:45
uint_t
unsigned int uint_t
unsigned integer
Definition: types.h:60
smpl_t
float smpl_t
short sample format (32 or 64 bits)
Definition: types.h:41
lsmp_t
double lsmp_t
long sample format (64 bits or more)
Definition: types.h:51